#include "testlib.h"
#include<algorithm>
#include <iostream>
#include<vector>

using namespace std;

// inf - input data
// ans - correct answer
// ouf - student's answer
// run: check inf ouf ans

int main(int argc, char ** argv)
{
    registerTestlibCmd(argc, argv);
    int N, pup_sum;
    string pup_ans = "", cor_ans = ans.readString();
    char c;

    N = inf.readInteger();
    ouf.skipBlanks();
    while (!ouf.eof()) {
        c = ouf.readChar();
        pup_ans += c;
        ouf.skipBlanks();
    }

    if (cor_ans == "IMPOSSIBLE") {
        if (pup_ans != "IMPOSSIBLE") {
            quit(_wa, "No way to get zero.");
        }
        else {
            quit(_ok, "OK");
        }
    }

    if ((pup_ans == "IMPOSSIBLE") && (cor_ans != "IMPOSSIBLE")) {
        quit(_wa, "There is a way to get zero.");
    }


    cout << pup_ans;
    if (pup_ans.size() != N) {
        quit(_wa, "Your string has wrong number of signs.");
    }

    pup_sum = 0;
    for (int i = 1; i < pup_ans.size() + 1; i++) {
        if (pup_ans[i - 1] == '+') {
            pup_sum += i;
        }
        else {
            pup_sum -= i;
        }
    }

    if (pup_sum != 0) {
        quit(_wa, "Wrong sign sequence");
    }
    quit(_ok, "OK");
}
